import { Component, HierarchicalData } from './types.cjs';

declare class Node<Kind extends string> implements Component<Kind> {
    kind: Kind;
    name: string;
    constructor(kind: Kind, name: string);
    getChildren(): undefined;
    hasChildren(): boolean;
    getHierarchy(): HierarchicalData;
    getChildByPaths(): undefined;
    set(): void;
    remove(): void;
}

export { Node };
