import { HierarchicalData, Component } from './types.js';

declare class Operator<TreeKind extends string> {
    private treeKind;
    private delimiter;
    private tree;
    constructor(treeKind: TreeKind, delimiter?: string);
    private setToRootOrParent;
    private removeFromRootOrParent;
    getHierarchy(): HierarchicalData;
    getChildByPaths(path: string, kind: string): Component | undefined;
    set(path: string, component: Component): void;
    remove(path: string, kind: string): void;
    copy(from: string, to: string, kind: string): boolean;
    move(from: string, to: string, kind: string): boolean;
    private getChildPaths;
    getNodePaths(kind: string): string[];
}

export { Operator };
