import { Component, HierarchicalData, Children } from './types.cjs';

declare class Tree<Kind extends string> implements Component<Kind> {
    kind: Kind;
    name: string;
    private children;
    constructor(kind: Kind, name: string);
    getChildByPaths(paths: string[], kind: string): Component<string> | undefined;
    getHierarchy(): HierarchicalData;
    getChildren(): Children;
    hasChildren(): boolean;
    set(pathName: string, component: Component): void;
    remove(pathName: string, component: Component<string>): void;
}

export { Tree };
