import {
  generateKey
} from "./chunk-4ENVCU5M.js";

// src/Tree.ts
var Tree = class {
  constructor(kind, name) {
    this.kind = kind;
    this.name = name;
  }
  children = {};
  getChildByPaths(paths, kind) {
    const [name, ...pathArray] = paths;
    if (!name) {
      return;
    }
    if (pathArray.length === 0) {
      const component = this.children[generateKey(kind, name)];
      return component;
    }
    const childTree = this.children[generateKey(this.kind, name)];
    return childTree && childTree.getChildByPaths(pathArray, kind);
  }
  getHierarchy() {
    const entires = Object.entries(this.children).map(([key, child]) => {
      return [key, child.getHierarchy()];
    });
    return {
      name: this.name,
      children: Object.fromEntries(entires)
    };
  }
  getChildren() {
    return this.children;
  }
  hasChildren() {
    return Object.keys(this.children).length === 0;
  }
  set(pathName, component) {
    const key = generateKey(component.kind, pathName);
    this.children[key] = component;
  }
  remove(pathName, component) {
    const targetKey = generateKey(component.kind, pathName);
    const entries = Object.entries(this.children).filter(([key]) => {
      return targetKey !== key;
    });
    this.children = Object.fromEntries(entries);
  }
};

export {
  Tree
};
//# sourceMappingURL=chunk-B3QRDH5K.js.map